/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.example.epo2.impl;

import com.example.epo2.*;

import java.text.ParsePosition;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <p>Custom data types <b>Date</b> and <b>SKU</b> implemented in Section 13.4.
 * <!-- end-user-doc -->
 * @generated
 */
public class EPO2FactoryImpl extends EFactoryImpl implements EPO2Factory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static EPO2Factory init()
  {
    try
    {
      EPO2Factory theEPO2Factory = (EPO2Factory)EPackage.Registry.INSTANCE.getEFactory("http://www.example.com/epo2.ecore"); 
      if (theEPO2Factory != null)
      {
        return theEPO2Factory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new EPO2FactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EPO2FactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case EPO2Package.ITEM: return createItem();
      case EPO2Package.US_ADDRESS: return createUSAddress();
      case EPO2Package.PURCHASE_ORDER: return createPurchaseOrder();
      case EPO2Package.SUPPLIER: return createSupplier();
      case EPO2Package.CUSTOMER: return createCustomer();
      case EPO2Package.GLOBAL_ADDRESS: return createGlobalAddress();
      case EPO2Package.GLOBAL_LOCATION: return createGlobalLocation();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case EPO2Package.ORDER_STATUS:
        return createOrderStatusFromString(eDataType, initialValue);
      case EPO2Package.SKU:
        return createSKUFromString(eDataType, initialValue);
      case EPO2Package.DATE:
        return createDateFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case EPO2Package.ORDER_STATUS:
        return convertOrderStatusToString(eDataType, instanceValue);
      case EPO2Package.SKU:
        return convertSKUToString(eDataType, instanceValue);
      case EPO2Package.DATE:
        return convertDateToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Item createItem()
  {
    ItemImpl item = new ItemImpl();
    return item;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public USAddress createUSAddress()
  {
    USAddressImpl usAddress = new USAddressImpl();
    return usAddress;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PurchaseOrder createPurchaseOrder()
  {
    PurchaseOrderImpl purchaseOrder = new PurchaseOrderImpl();
    return purchaseOrder;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Supplier createSupplier()
  {
    SupplierImpl supplier = new SupplierImpl();
    return supplier;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Customer createCustomer()
  {
    CustomerImpl customer = new CustomerImpl();
    return customer;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GlobalAddress createGlobalAddress()
  {
    GlobalAddressImpl globalAddress = new GlobalAddressImpl();
    return globalAddress;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GlobalLocation createGlobalLocation()
  {
    GlobalLocationImpl globalLocation = new GlobalLocationImpl();
    return globalLocation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public OrderStatus createOrderStatusFromString(EDataType eDataType, String initialValue)
  {
    OrderStatus result = OrderStatus.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertOrderStatusToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated NOT
   */
  public String createSKUFromString(EDataType eDataType, String initialValue) // 13.4
  {
    return initialValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated NOT
   */
  public String convertSKUToString(EDataType eDataType, Object instanceValue) // 13.4
  {
    return (String)instanceValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated NOT
   */
  public Date createDateFromString(EDataType eDataType, String initialValue) // 13.4
  {
    if (initialValue == null) return null;

    SimpleDateFormat format = new SimpleDateFormat("yyyy.MM.dd");
    ParsePosition position = new ParsePosition(0);
    Date result = format.parse(initialValue, position);
    if (position.getIndex() == 0)
    {
      throw new IllegalArgumentException("Date must be of format yyyy.MM.dd");
    }
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated NOT
   */
  public String convertDateToString(EDataType eDataType, Object instanceValue) // 13.4
  {
    if (instanceValue == null) return null;
    SimpleDateFormat format = new SimpleDateFormat("yyyy.MM.dd");
    return format.format((Date)instanceValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EPO2Package getEPO2Package()
  {
    return (EPO2Package)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static EPO2Package getPackage()
  {
    return EPO2Package.eINSTANCE;
  }

} //EPO2FactoryImpl
