/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package com.example.epo1.provider;


import com.example.epo1.Customer;
import com.example.epo1.EPO1Factory;
import com.example.epo1.EPO1Package;
import com.example.epo1.PurchaseOrder;

import java.util.Collection;
import java.util.List;

import org.eclipse.emf.common.notify.AdapterFactory;
import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.ResourceLocator;

import org.eclipse.emf.ecore.EStructuralFeature;

import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITableItemLabelProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;
import org.eclipse.emf.edit.provider.ItemPropertyDescriptor;
import org.eclipse.emf.edit.provider.ItemProviderAdapter;
import org.eclipse.emf.edit.provider.ViewerNotification;

/**
 * This is the item provider adapter for a {@link com.example.epo1.PurchaseOrder} object.
 * <!-- begin-user-doc -->
 * 19.2.2
 * @implements ITableItemLabelProvider
 * <!-- end-user-doc -->
 * @generated
 */
public class PurchaseOrderItemProvider
  extends ItemProviderAdapter
  implements
    IEditingDomainItemProvider,
    IStructuredItemContentProvider,
    ITreeItemContentProvider,
    IItemLabelProvider,
    IItemPropertySource,
    ITableItemLabelProvider
{
  /**
   * This constructs an instance from a factory and a notifier.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PurchaseOrderItemProvider(AdapterFactory adapterFactory)
  {
    super(adapterFactory);
  }

  /**
   * Returns the column label text. Column 0 identifies the purchase order
   * itself, and column 1 identifies the associated customer. 
   */
  @Override
  public String getColumnText(Object object, int columnIndex) // 19.2.2
  {
    if (columnIndex == 0) return getText(object);
    Customer customer = ((PurchaseOrder)object).getCustomer();
    if (customer == null) return "";

    IItemLabelProvider itemLabelProvider = (IItemLabelProvider)adapterFactory.adapt(customer, IItemLabelProvider.class);
    return itemLabelProvider.getText(customer);
  }

  /**
   * Returns the column label image. Column 0 identifies the purchase order
   * itself, and column 1 identifies the associated customer. 
   */
  @Override
  public Object getColumnImage(Object object, int columnIndex) // 19.2.2
  {
    if (columnIndex == 0) return getImage(object);
    Customer customer = ((PurchaseOrder)object).getCustomer();
    if (customer == null) return getResourceLocator().getImage("full/obj16/Customer");

    IItemLabelProvider itemLabelProvider = (IItemLabelProvider)adapterFactory.adapt(customer, IItemLabelProvider.class);
    return itemLabelProvider.getImage(customer);
  }

  /**
   * This returns the property descriptors for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public List<IItemPropertyDescriptor> getPropertyDescriptors(Object object)
  {
    if (itemPropertyDescriptors == null)
    {
      super.getPropertyDescriptors(object);

      addCommentPropertyDescriptor(object);
      addOrderDatePropertyDescriptor(object);
      addStatusPropertyDescriptor(object);
      addPreviousOrderPropertyDescriptor(object);
      addCustomerPropertyDescriptor(object);
    }
    return itemPropertyDescriptors;
  }

  /**
   * This adds a property descriptor for the Comment feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addCommentPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_PurchaseOrder_comment_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_PurchaseOrder_comment_feature", "_UI_PurchaseOrder_type"),
         EPO1Package.Literals.PURCHASE_ORDER__COMMENT,
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Order Date feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addOrderDatePropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_PurchaseOrder_orderDate_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_PurchaseOrder_orderDate_feature", "_UI_PurchaseOrder_type"),
         EPO1Package.Literals.PURCHASE_ORDER__ORDER_DATE,
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Status feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addStatusPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_PurchaseOrder_status_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_PurchaseOrder_status_feature", "_UI_PurchaseOrder_type"),
         EPO1Package.Literals.PURCHASE_ORDER__STATUS,
         true,
         false,
         false,
         ItemPropertyDescriptor.GENERIC_VALUE_IMAGE,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Previous Order feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addPreviousOrderPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_PurchaseOrder_previousOrder_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_PurchaseOrder_previousOrder_feature", "_UI_PurchaseOrder_type"),
         EPO1Package.Literals.PURCHASE_ORDER__PREVIOUS_ORDER,
         true,
         false,
         true,
         null,
         null,
         null));
  }

  /**
   * This adds a property descriptor for the Customer feature.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected void addCustomerPropertyDescriptor(Object object)
  {
    itemPropertyDescriptors.add
      (createItemPropertyDescriptor
        (((ComposeableAdapterFactory)adapterFactory).getRootAdapterFactory(),
         getResourceLocator(),
         getString("_UI_PurchaseOrder_customer_feature"),
         getString("_UI_PropertyDescriptor_description", "_UI_PurchaseOrder_customer_feature", "_UI_PurchaseOrder_type"),
         EPO1Package.Literals.PURCHASE_ORDER__CUSTOMER,
         true,
         false,
         true,
         null,
         null,
         null));
  }

  /**
   * This specifies how to implement {@link #getChildren} and is used to deduce an appropriate feature for an
   * {@link org.eclipse.emf.edit.command.AddCommand}, {@link org.eclipse.emf.edit.command.RemoveCommand} or
   * {@link org.eclipse.emf.edit.command.MoveCommand} in {@link #createCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Collection<? extends EStructuralFeature> getChildrenFeatures(Object object)
  {
    if (childrenFeatures == null)
    {
      super.getChildrenFeatures(object);
      childrenFeatures.add(EPO1Package.Literals.PURCHASE_ORDER__ITEMS);
      childrenFeatures.add(EPO1Package.Literals.PURCHASE_ORDER__BILL_TO);
      childrenFeatures.add(EPO1Package.Literals.PURCHASE_ORDER__SHIP_TO);
    }
    return childrenFeatures;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EStructuralFeature getChildFeature(Object object, Object child)
  {
    // Check the type of the specified child object and return the proper feature to use for
    // adding (see {@link AddCommand}) it as a child.

    return super.getChildFeature(object, child);
  }

  /**
   * This returns PurchaseOrder.gif.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object getImage(Object object)
  {
    return overlayImage(object, getResourceLocator().getImage("full/obj16/PurchaseOrder"));
  }

  /**
   * This returns the label text for the adapted class.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getText(Object object)
  {
    String label = ((PurchaseOrder)object).getComment();
    return label == null || label.length() == 0 ?
      getString("_UI_PurchaseOrder_type") :
      getString("_UI_PurchaseOrder_type") + " " + label;
  }

  /**
   * This handles model notifications by calling {@link #updateChildren} to update any cached
   * children and by creating a viewer notification, which it passes to {@link #fireNotifyChanged}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void notifyChanged(Notification notification)
  {
    updateChildren(notification);

    switch (notification.getFeatureID(PurchaseOrder.class))
    {
      case EPO1Package.PURCHASE_ORDER__COMMENT:
      case EPO1Package.PURCHASE_ORDER__ORDER_DATE:
      case EPO1Package.PURCHASE_ORDER__STATUS:
      case EPO1Package.PURCHASE_ORDER__CUSTOMER:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), false, true));
        return;
      case EPO1Package.PURCHASE_ORDER__ITEMS:
      case EPO1Package.PURCHASE_ORDER__BILL_TO:
      case EPO1Package.PURCHASE_ORDER__SHIP_TO:
        fireNotifyChanged(new ViewerNotification(notification, notification.getNotifier(), true, false));
        return;
    }
    super.notifyChanged(notification);
  }

  /**
   * This adds {@link org.eclipse.emf.edit.command.CommandParameter}s describing the children
   * that can be created under this object.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected void collectNewChildDescriptors(Collection<Object> newChildDescriptors, Object object)
  {
    super.collectNewChildDescriptors(newChildDescriptors, object);

    newChildDescriptors.add
      (createChildParameter
        (EPO1Package.Literals.PURCHASE_ORDER__ITEMS,
         EPO1Factory.eINSTANCE.createItem()));

    newChildDescriptors.add
      (createChildParameter
        (EPO1Package.Literals.PURCHASE_ORDER__BILL_TO,
         EPO1Factory.eINSTANCE.createUSAddress()));

    newChildDescriptors.add
      (createChildParameter
        (EPO1Package.Literals.PURCHASE_ORDER__SHIP_TO,
         EPO1Factory.eINSTANCE.createUSAddress()));
  }

  /**
   * This returns the label text for {@link org.eclipse.emf.edit.command.CreateChildCommand}.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String getCreateChildText(Object owner, Object feature, Object child, Collection<?> selection)
  {
    Object childFeature = feature;
    Object childObject = child;

    boolean qualify =
      childFeature == EPO1Package.Literals.PURCHASE_ORDER__BILL_TO ||
      childFeature == EPO1Package.Literals.PURCHASE_ORDER__SHIP_TO;

    if (qualify)
    {
      return getString
        ("_UI_CreateChild_text2",
         new Object[] { getTypeText(childObject), getFeatureText(childFeature), getTypeText(owner) });
    }
    return super.getCreateChildText(owner, feature, child, selection);
  }

  /**
   * Return the resource locator for this item provider's resources.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public ResourceLocator getResourceLocator()
  {
    return ExtendedPO1EditPlugin.INSTANCE;
  }

}
